#!/usr/bin/perl -w

use strict;
use Encode;
use HTML::Entities;
use LinkClean;

loadmappings;

my %my_user;

open USERS, "< ../data3/network_users.txt" or die;
while (<USERS>) {
  chomp;
  $my_user{$_} = 1;
}
close USERS;

my $post_url = undef;
my $post_gid = undef;
my $post_src = undef;
my $post_lng = undef;
my $description = undef;

while (<>) {
  $post_url = $1 if m/<link>(.*)<\/link>/;
  $post_gid = $1 if m/<post:resource_guid>(.*)<\/post:resource_guid>/;
  $post_src = $1 if m/<dc:source>(.*)<\/dc:source>/;
  $post_lng = $1 if m/<dc:lang>(.*)<\/dc:lang>/;

  if (m/<description>/) {
    $description = $_;
    while (<>) {
      $description .= " " . $_;
      last if m/<\/description>/;
    }
  }

  if (m/<\/item>/) {
		if (defined $post_url) {
      $post_url = "$post_src/$post_url" unless $post_url =~ m|^https?://|;
		  my $usr = user($post_url);

		  if (defined $usr && exists $my_user{$usr}) {
        $description =~ s/<\/?description>//g;
        $description = decode('UTF-8', $description);
        $description = decode_entities($description);
        $description = decode_entities($description);
        $description =~ s|<.*?>||g;
        $description =~ s|\W+| |g;
        $description =~ s|^ ||g;
        $description =~ s| $||g;
        my @words = split " ", $description;
        print "$usr $post_gid $post_lng ", scalar @words, " : ", encode('UTF-8', $description), "\n";
      }
    }

    $post_url = undef;
    $post_gid = undef;
    $post_src = undef;
    $post_lng = undef;
    $description = undef;
  }
}
